/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

#ifndef __COMPOSED_COMMAND__
#define __COMPOSED_COMMAND__


//------------------------------------------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------------------------------------------
#include <iostream>
#include <deque>
#include "CommandObject.h"

/*
class CommandObject;
class ExecutableCommand;*/

class ComposedCommand : public CommandObject{

//------------------------------------------------------------------------------------------------------------
// Constructors & Destructors
//------------------------------------------------------------------------------------------------------------
public:

	ComposedCommand( );

	virtual ~ComposedCommand( );
//------------------------------------------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------------------------------------------
	
	/*
	* Adds a command to the list of command
	* @param nwCommand Is the new command to include
	*/
	void addCommand(CommandObject * nwCommand);	

	/*
	* Includes the command into the given queue for execution
	* @param executionQueue Is the queue in which is included the command
	*/
	virtual void includeToExecute(std::deque<CommandObject *> &executionQueue);

	/*
	* Counts the command(s)
	* @return The value of commands that represents this
	*/
	virtual int count();

	/*
	* Method that clears the command
	*/
	virtual void clear();

//------------------------------------------------------------------------------------------------------------
// Constants
//------------------------------------------------------------------------------------------------------------

private: 	
//------------------------------------------------------------------------------------------------------------
// Attributes
//------------------------------------------------------------------------------------------------------------
	
	/*
	* Represents the internal commands 
	*/
	std::deque< CommandObject *> internalCommands;	
	
};
#endif
